Index: main/waeup.ikoba/trunk/src/waeup/ikoba/browser/pages.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/browser/pages.py	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/browser/pages.py	(revision 11979)
@@ -274,4 +274,5 @@
                         self.request.principal.id]
                     rel_link = '/customers/%s' % self.request.principal.id
+                    # Maybe we need this in Ikoba too
                     #if customer.personal_data_expired:
                     #    rel_link = '/customers/%s/edit_personal' % (
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 11979)
@@ -206,6 +206,6 @@
     @action('Set password now', style='primary')
     def setPassword(self, *args, **data):
-        kofa_utils = getUtility(IIkobaUtils)
-        password = kofa_utils.genPassword()
+        ikoba_utils = getUtility(IIkobaUtils)
+        password = ikoba_utils.genPassword()
         self.context.setTempPassword(self.request.principal.id, password)
         self.context.writeLogMessage(
@@ -287,6 +287,6 @@
         usertype = getattr(self.request.principal,
                            'user_type', 'system').title()
-        kofa_utils = getUtility(IIkobaUtils)
-        success = kofa_utils.sendContactForm(
+        ikoba_utils = getUtility(IIkobaUtils)
+        success = ikoba_utils.sendContactForm(
                 self.request.principal.title,email,
                 self.context.display_fullname,self.context.email,
@@ -489,6 +489,6 @@
             return
 
-        kofa_utils = getUtility(IIkobaUtils)
-        password = kofa_utils.genPassword()
+        ikoba_utils = getUtility(IIkobaUtils)
+        password = ikoba_utils.genPassword()
         mandate = PasswordMandate()
         mandate.params['password'] = password
@@ -501,5 +501,5 @@
         url_info = u'Confirmation link: %s' % mandate_url
         msg = _('You have successfully requested a password for the')
-        if kofa_utils.sendCredentials(IUserAccount(customer),
+        if ikoba_utils.sendCredentials(IUserAccount(customer),
             password, url_info, msg):
             email_sent = customer.email
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/basemanagepage.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/basemanagepage.pt	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/basemanagepage.pt	(revision 11979)
@@ -1,4 +1,4 @@
 <form action="." tal:attributes="action request/URL" method="post"
-      i18n:domain="waeup.kofa" enctype="multipart/form-data"
+      i18n:domain="waeup.ikoba" enctype="multipart/form-data"
       autocomplete="off">
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/changepassword.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/changepassword.pt	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/changepassword.pt	(revision 11979)
@@ -1,4 +1,4 @@
 <form action="." tal:attributes="action request/URL" method="post"
-      i18n:domain="waeup.kofa" enctype="multipart/form-data">
+      i18n:domain="waeup.ikoba" enctype="multipart/form-data">
 
   <input type="hidden" name="customer_id" value=""
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/containermanagepage.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/containermanagepage.pt	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/containermanagepage.pt	(revision 11979)
@@ -1,3 +1,3 @@
-<form method="POST" i18n:domain="waeup.kofa" class="form-inline">
+<form method="POST" i18n:domain="waeup.ikoba" class="form-inline">
 <br />
   <div class="form-group">
@@ -31,5 +31,5 @@
 
     <br /><br />
-    <table class="kofa-data-table dataTableManage">
+    <table class="ikoba-data-table dataTableManage">
       <thead>
     	<tr>
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/containerpage.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/containerpage.pt	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/containerpage.pt	(revision 11979)
@@ -1,3 +1,3 @@
-<form method="POST" i18n:domain="waeup.kofa" class="form-inline">
+<form method="POST" i18n:domain="waeup.ikoba" class="form-inline">
 <br />
   <div class="form-group">
@@ -29,5 +29,5 @@
   <input type="hidden" name="old_searchtype"
        tal:attributes="value view/searchtype" />
-  <table class="kofa-data-table dataTable">
+  <table class="ikoba-data-table dataTable">
     <thead>
     <tr>
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/imageupload.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/imageupload.pt	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/imageupload.pt	(revision 11979)
@@ -1,3 +1,3 @@
-<tr i18n:domain="waeup.kofa">
+<tr i18n:domain="waeup.ikoba">
   <td class="fieldname">
     <span tal:replace="viewlet/label">FILENAME</span>:
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/loginasstep1.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/loginasstep1.pt	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/loginasstep1.pt	(revision 11979)
@@ -1,3 +1,3 @@
-<form i18n:domain="waeup.kofa" method="post">
+<form i18n:domain="waeup.ikoba" method="post">
   <p i18n:translate="login_as_intro_1">
     Kofa is creating a temporary customer password which will replace the
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/requestpw.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/requestpw.pt	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/requestpw.pt	(revision 11979)
@@ -1,4 +1,4 @@
 <form action="." tal:attributes="action request/URL" method="post"
-    i18n:domain="waeup.kofa" enctype="multipart/form-data">
+    i18n:domain="waeup.ikoba" enctype="multipart/form-data">
 
   <table class="form-table">
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/requestpwmailsent.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/requestpwmailsent.pt	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/requestpwmailsent.pt	(revision 11979)
@@ -1,3 +1,3 @@
-<tal:only_email condition = "not: view/password" i18n:domain="waeup.kofa">
+<tal:only_email condition = "not: view/password" i18n:domain="waeup.ikoba">
   <p tal:condition = "view/email">
     <span i18n:translate=""> An email with your user name and password
@@ -17,5 +17,5 @@
 </tal:only_email>
 
-<tal:credentials condition = "view/password" i18n:domain="waeup.kofa">
+<tal:credentials condition = "view/password" i18n:domain="waeup.ikoba">
   <h3 i18n:translate="">Your login credentials are:</h3>
   <table class="bordered-table span6">
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/viewlets.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/viewlets.py	(revision 11978)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/viewlets.py	(revision 11979)
@@ -127,6 +127,6 @@
         url = self.view.url(self.context.customer, self.link)
         # Here we know that the cookie has been set
-        lang = self.request.cookies.get('kofa.language')
-        text = translate(self.text, 'waeup.kofa',
+        lang = self.request.cookies.get('ikoba.language')
+        text = translate(self.text, 'waeup.ikoba',
             target_language=lang)
         if not self.link: