Index: main/waeup.ikoba/trunk/src/waeup/ikoba/catalog.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/catalog.py	(revision 12005)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/catalog.py	(revision 12006)
@@ -124,11 +124,4 @@
             if idx_name == 'catalog':
                 continue
-            if value is not None:
-                if 'session' in idx_name or 'level' in idx_name:
-                    value = int(value)
-                if idx_name in ('level', 'current_level'):
-                    value = int(value)
-                    if value not in (10, 999):
-                        value = (value, value + 90)
             if not isinstance(value, tuple):
                 value = (value, value)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/catalog.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/catalog.py	(revision 12005)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/catalog.py	(revision 12006)
@@ -1,3 +1,3 @@
-## $Id: catalog.py 10465 2013-08-07 11:18:43Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12005)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12006)
@@ -1,3 +1,3 @@
-## $Id: export.py 11757 2014-07-10 12:20:30Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
@@ -27,5 +27,5 @@
 from waeup.ikoba.customers.catalog import CustomersQuery
 from waeup.ikoba.customers.interfaces import (
-    ICustomer, ICSVCustomerExporter)
+    ICustomer, ICSVCustomerExporter, ICustomerDocument)
 from waeup.ikoba.utils.batching import ExporterBase
 from waeup.ikoba.utils.helpers import iface_names, to_timezone
@@ -33,5 +33,5 @@
 #: A tuple containing all exporter names referring to customers or
 #: subobjects thereof.
-EXPORTER_NAMES = ('customers', )
+EXPORTER_NAMES = ('customers', 'customerdocuments')
 
 
@@ -40,4 +40,13 @@
     """
     return cust_filter.query()
+
+def get_documents(customers):
+    """Get all documents of `customers`.
+    """
+    documents = []
+    for customer in customers:
+        for document in customer.get('documents', {}).values():
+            documents.append(document)
+    return documents
 
 
@@ -127,2 +136,30 @@
             CustomersExporter, self).mangle_value(
             value, name, context=context)
+
+class CustomerDocumentsExporter(grok.GlobalUtility, CustomerExporterBase):
+    """Exporter for CustomerDocument instances.
+    """
+    grok.name('customerdocuments')
+
+    #: Fieldnames considered by this exporter
+    fields = tuple(
+        sorted(iface_names(
+            ICustomerDocument, exclude_attribs=False))) + (
+            'customer_id',)
+
+    #: The title under which this exporter will be displayed
+    title = _(u'Customer Documents')
+
+    def filter_func(self, x, **kw):
+        return get_documents(x, **kw)
+
+    def mangle_value(self, value, name, context=None):
+        """Treat location values special.
+        """
+        if context is not None:
+            customer = context.customer
+            if name in ('customer_id',) and customer is not None:
+                value = getattr(customer, name, None)
+        return super(
+            CustomerDocumentsExporter, self).mangle_value(
+            value, name, context=context)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_batching.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_batching.py	(revision 12005)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_batching.py	(revision 12006)
@@ -38,4 +38,5 @@
     CustomerProcessor, CustomerDocumentProcessor)
 from waeup.ikoba.customers.customer import Customer
+from waeup.ikoba.customers.documents import CustomerDocument
 from waeup.ikoba.testing import FunctionalLayer, FunctionalTestCase
 
@@ -116,4 +117,7 @@
         customer.nationality = u'NG'
 
+        document = CustomerDocument()
+        document.title = u'My Document'
+        customer['documents'].addDocument(document)
         return customer
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_customer.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_customer.py	(revision 12005)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_customer.py	(revision 12006)
@@ -1,3 +1,3 @@
-## $Id: test_customer.py 10059 2013-04-05 08:11:29Z henrik $
+## $Id$
 ##
 ## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann